﻿using System;
using System.Threading.Tasks;
using System.Collections.Concurrent;
using System.Linq;

namespace TPP.Examen2 {
    
    public class ProductoMatrices {

        static void Main(string[] args)
        {
            short[,] A = CrearMatrizAleatoria(5, 6, 0, 10);
            short[,] B = CrearMatrizAleatoria(6, 4, 0, 10);
            short[,] C;
            System.Console.WriteLine("TPP. EXAMEN 2.");
            System.Console.WriteLine("CURSO 2012-2013");
            System.Console.WriteLine("PRODUCTO PARALELO DE DOS MATRICES RECTANGULARES C = A*B\n");
            System.Console.WriteLine("\nMatriz A"); mostrarMatriz(A);

            System.Console.WriteLine("\nMatriz B"); mostrarMatriz(B);

            // Ejercicio 0.
            C = ejercicio0(A, B);
            System.Console.WriteLine("\nEjercicio0. C = A*B monohilo"); mostrarMatriz(C);

            // Ejercicio 1.
            C = ejercicio1(A, B);
            System.Console.WriteLine("\nEjercicio1. C= A*B sin TPL y con N*M hilos"); mostrarMatriz(C);

            // Ejercicio 2.
            C = ejercicio2(A, B, 10);
            System.Console.WriteLine("\nEjercicio2. C= A*B sin TPL y con <=N*M hilos"); mostrarMatriz(C);

            
            // Ejercicio 3.
            C = ejercicio3(A, B);
            System.Console.WriteLine("\nEjercicio3. C = A*B con TPL y con <=N*M hilos"); mostrarMatriz(C);
        }

        //
        /// <summary>
        /// Ejercicio 0. RESUELTO.
        // Versión secual monohilo del producto de dos matrices rectangulares.
        // Los restantes ejercicios deberán dar el mismo resultado que esta versión.
        /// </summary>
        /// <param name="A"></param>
        /// <param name="B"></param>
        /// <returns>
        /// C = A*B
        /// </returns>        
        public static short[,] ejercicio0(short[,] A, short[,] B)
        {
            short[,] C = new short [A.GetLength(0), B.GetLength(1)];

           for(short i = 0; i < C.GetLength(0); i++)
               for (short j = 0; j < C.GetLength(1); j++)
               {
                   short total = 0;
                   for (short k = 0; k < A.GetLength(1); k++)
                       total += (short)(A[i, k] * B[k, j]);
                   C[i, j] = total;
               }
           return C;
        }

        //
        /// <summary>
        // Ejercicio1. A RELLENAR.
        // Versión paralela del producto de dos matrices rectangulares.
        // El número de hilos deberá ser igual a A.GetLength(0)*B.GetLength(1)
        // No se puede usar TPL.
        /// El código que aparece comentado es opcional y puede suprimirse si no se requiere.
        ///  // Master1 master = ....
        /// </summary>
        /// <param name="A"></param>
        /// <param name="B"></param>
        /// <returns>
        /// C = A*B
        /// </returns>
        public static short[,] ejercicio1(short[,] A, short[,] B)
        {

          short[,] C = null;
          //Master1 master = new Master1(A, B);
          //short[,] C = master.CalcularProducto();
          
        return C;
        }
        //

        //
        /// <summary>
        /// Ejercicio2. A RELLENAR.
        /// Versión paralela del producto de dos matrices rectangulares.
        /// El número de hilos puede ser <= A.GetLength(0)*B.GetLength(1)
        /// No se puede usar TPL.
        /// El código que aparece comentado es opcional y puede suprimirse si no se requiere.
        ///  // Master2 master = ....
        /// </summary>
        /// <param name="A"></param>
        /// <param name="B"></param>
        /// <returns>
        /// C = A*B
        /// </returns>
        public static short[,] ejercicio2(short[,] A, short[,] B, short numeroHilos)
        {
            short[,] C = null;
            //Master2 master = new Master2(A, B, numeroHilos);
            //short[,] C = master.CalcularProducto();

            return C;
        }
        
        /// <summary>
        /// Ejercicio3. A RELLENAR
        /// Versión paralela del producto de dos matrices rectangulares.
        /// El número de hilos puede ser <= A.GetLength(0)*B.GetLength(1)
        /// Se debe usar TPL.
        /// El código que aparece comentado es opcional y puede suprimirse si no se requiere.
        ///  // Master3 master = ....
        /// </summary>
        /// <param name="A"></param>
        /// <param name="B"></param>
        /// <returns>
        /// C = A*B
        /// </returns>
        public static short[,] ejercicio3(short[,] A, short[,] B)
        {
            short[,] C = null;
            //Master3 master = new Master3(A, B, numeroHilos);
            //short[,] C = master.CalcularProducto();
            

            return C;
        }

        public static short[,] CrearMatrizAleatoria(short filas, short columnas, short menor, short mayor) {
            short[,] vector = new short[filas, columnas];
            Random random = new Random();
            for (int i = 0; i < filas; i++)
                for (int j = 0; j < columnas; j++)
                   vector[i,j] = (short)random.Next(menor, mayor + 1);
            return vector;
        }
        public static void mostrarMatriz(short [,] matriz)
        {
            if (matriz == null) System.Console.WriteLine("MATRIZ VACIA");
            else
            for (int i = 0; i < matriz.GetLength(0); i++)
            {
                for (int j = 0; j < matriz.GetLength(1); j++)
                    System.Console.Write(matriz[i,j]+" ");
                System.Console.WriteLine();
            }
        }
    }

}
